#
# spec file for package libqt5-qtwebengine
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define qt5_snapshot 0

Name:           libqt5-qtwebengine
Version:        5.5.0
Release:        0
Summary:        Qt 5 WebEngine Library
License:        SUSE-LGPL-2.1-with-digia-exception-1.1 or GPL-3.0
Group:          Development/Libraries/X11
Url:            http://qt.digia.com
%define base_name libqt5
%define real_version 5.5.0
%define so_version 5.5.0
%define tar_version qtwebengine-opensource-src-%{real_version}
Source:         %{tar_version}.tar.xz
Source1:        baselibs.conf
# http://www.chromium.org/blink not ported to PowerPC
ExcludeArch:    ppc ppc64 ppc64le
Patch0:         strip.diff
Patch1:         gyp_conf.patch
# PATCH-FIX-OPENSUSE gcc50-fixes.diff -- Fix the detection of the Gcc 5.x compiler
Patch2:         gcc50-fixes.diff
Patch3:         gyp-arm64.patch
Patch4:         sandbox-linux-arm64.patch
BuildRequires:  bison
BuildRequires:  fdupes
BuildRequires:  flac-devel
BuildRequires:  flex
BuildRequires:  gperf
BuildRequires:  hunspell-devel
BuildRequires:  krb5
BuildRequires:  krb5-devel
BuildRequires:  libcap-devel
BuildRequires:  libgcrypt-devel
BuildRequires:  libicu-devel
BuildRequires:  libjpeg-devel
BuildRequires:  libpng-devel
BuildRequires:  libqt5-qtbase-private-headers-devel >= %{version}
BuildRequires:  libqt5-qtdeclarative-private-headers-devel >= %{version}
BuildRequires:  libqt5-qtwebchannel-private-headers-devel >= %{version}
BuildRequires:  libqt5-qtxmlpatterns-private-headers-devel >= %{version}
BuildRequires:  pam-devel
BuildRequires:  pciutils-devel
BuildRequires:  perl-JSON
BuildRequires:  pkg-config
BuildRequires:  python
BuildRequires:  python-devel
BuildRequires:  python-xml
BuildRequires:  re2c
BuildRequires:  snappy-devel
BuildRequires:  sqlite3-devel
BuildRequires:  update-desktop-files
BuildRequires:  usbutils
BuildRequires:  util-linux
BuildRequires:  valgrind-devel
BuildRequires:  wdiff
BuildRequires:  xz
BuildRequires:  yasm
BuildRequires:  perl(Switch)
BuildRequires:  pkgconfig(alsa)
BuildRequires:  pkgconfig(bzip2)
BuildRequires:  pkgconfig(cairo)
BuildRequires:  pkgconfig(dbus-1)
BuildRequires:  pkgconfig(fontconfig)
BuildRequires:  pkgconfig(freetype2)
BuildRequires:  pkgconfig(gio-2.0)
BuildRequires:  pkgconfig(glib-2.0)
BuildRequires:  pkgconfig(gmodule-2.0)
BuildRequires:  pkgconfig(gobject-2.0)
BuildRequires:  pkgconfig(gthread-2.0)
%if 0%{?suse_version} >= 1315
BuildRequires:  pkgconfig(jsoncpp)
%endif
BuildRequires:  pkgconfig(libcrypto)
BuildRequires:  pkgconfig(libdrm)
BuildRequires:  pkgconfig(libevent)
BuildRequires:  pkgconfig(libexif)
BuildRequires:  pkgconfig(libmtp)
BuildRequires:  pkgconfig(libpci)
BuildRequires:  pkgconfig(libpng)
BuildRequires:  pkgconfig(libpulse)
BuildRequires:  pkgconfig(libsrtp)
BuildRequires:  pkgconfig(libudev)
BuildRequires:  pkgconfig(libusb-1.0)
BuildRequires:  pkgconfig(libwebp)
BuildRequires:  pkgconfig(libxml-2.0)
BuildRequires:  pkgconfig(libxslt)
BuildRequires:  pkgconfig(nspr)
BuildRequires:  pkgconfig(nss)
BuildRequires:  pkgconfig(opus)
BuildRequires:  pkgconfig(pangocairo)
BuildRequires:  pkgconfig(pangoft2)
BuildRequires:  pkgconfig(protobuf)
BuildRequires:  pkgconfig(speex)
BuildRequires:  pkgconfig(vpx)
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(xcomposite)
BuildRequires:  pkgconfig(xcursor)
BuildRequires:  pkgconfig(xdamage)
BuildRequires:  pkgconfig(xext)
BuildRequires:  pkgconfig(xfixes)
BuildRequires:  pkgconfig(xi)
BuildRequires:  pkgconfig(xrandr)
BuildRequires:  pkgconfig(xrender)
BuildRequires:  pkgconfig(xscrnsaver)
BuildRequires:  pkgconfig(xt)
BuildRequires:  pkgconfig(xtst)
BuildRequires:  pkgconfig(zlib)
%if %qt5_snapshot
#to create the forwarding headers
BuildRequires:  perl
%endif
%requires_ge libQt5Network5
%requires_ge libQtQuick5
%requires_ge libQt5Widgets5
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Qt is a set of libraries for developing applications.

%prep
%setup -q -n qtwebengine-opensource-src-%{real_version}
%patch1 -p1
%patch2 -p0
%patch3 -p1
%patch4 -p1
sed -i 's|$(STRIP)|strip|g' src/core/core_module.pro

#pushd src/3rdparty/chromium/third_party/
#popd

%package devel
Summary:        Qt Development Kit
Group:          Development/Libraries/X11
Requires:       %{name} = %{version}

%description devel
You need this package, if you want to compile programs with qtsensors.

%package private-headers-devel
Summary:        Non-ABI stable experimental API
Group:          Development/Libraries/C and C++
BuildArch:      noarch
Requires:       %{name}-devel = %{version}
Requires:       libqt5-qtbase-private-headers-devel >= %{version}
Requires:       libqt5-qtdeclarative-private-headers-devel >= %{version}

%description private-headers-devel
This package provides private headers of libqt5-qtsensors that are normally
not used by application development and that do not have any ABI or
API guarantees. The packages that build against these have to require
the exact Qt version.

%package examples
Summary:        Qt5 location examples
Group:          Development/Libraries/X11
Recommends:     %{name}-devel

%description examples
Examples for libqt5-qtwebengine module.

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%build
%if %qt5_snapshot
#force the configure script to generate the forwarding headers (it checks whether .git directory exists)
mkdir .git
%endif
myconf+=" -Duse_system_expat=1
          -Duse_system_flac=1
%if 0%{?suse_version} >= 1315
          -Duse_system_jsoncpp=1
%endif
          -Duse_system_libevent=1
          -Duse_system_libjpeg=1
          -Duse_system_libpng=1
          -Duse_system_libusb=1
          -Duse_system_libxml=1
          -Duse_system_libxslt=1
          -Duse_system_opus=1
          -Duse_system_snappy=1
          -Duse_system_speex=1"

# gyp files for these 2 system libs are using some magical chromium tool which doesn't exist in qtwebengine tarball
# building with system zlib needs system minizip, which we don't have in openSUSE (yet)
# gen/shim_headers/re2/target/third_party/re2/re2/re2.h:8:21: fatal error: re2/re2.h: No such file or directory
# ../../../src/3rdparty/chromium/media/filters/vpx_video_decoder.cc:270:58: error: 'vpx_codec_set_frame_buffer_functions' was not declared in this scope
# /home/abuild/rpmbuild/BUILD/qtwebengine-opensource-src-5.4.1/src/core/Release/../../../src/3rdparty/chromium/third_party/WebKit/Source/modules/webdatabase/sqlite/SQLiteFileSystemPosix.cpp:79: undefined reference to `chromium_sqlite3_destroy_reusable_file_handle'
%if 0
myconf+=" -Duse_system_harfbuzz=1
          -Duse_system_icu=1
          -Duse_system_libwebp=1
          -Duse_system_libvpx=1
          -Duse_system_openssl=1
          -Duse_system_re2=1
          -Duse_system_zlib=1
          -Duse_system_sqlite=1"
%endif

pushd src/3rdparty/chromium/
build/linux/unbundle/replace_gyp_files.py $myconf
popd

%if 0
sed -i 's|<(harfbuzz_libraries)|harfbuzz-icu|g' src/3rdparty/chromium/third_party/harfbuzz-ng/harfbuzz.gyp
sed -i 's|<(libraries)|libwebpdemux|g' src/3rdparty/chromium/third_party/libwebp/libwebp.gyp
%endif

%ifnarch x86_64
RPM_OPT_FLAGS="$RPM_OPT_FLAGS "
export RPM_OPT_FLAGS=${RPM_OPT_FLAGS/-g / }
%endif
%qmake5 QMAKE_LFLAGS+="-Wl,--no-keep-memory -Wl,--hash-size=31 -Wl,--reduce-memory-overheads"

%make_jobs

%install
%qmake5_install
#cat %{buildroot}/%{_libdir}/pkgconfig/Qt*Web*.pc
find %{buildroot}/%{_libdir} -type f -name '*la' -print -exec perl -pi -e 's, -L%{_builddir}/\S+,,g' {} \;
find %{buildroot}/%{_libdir} -type f -name '*pc' -print -exec perl -pi -e "s, -L$RPM_BUILD_DIR/?\S+,,g" {} \; -exec sed -i -e "s,^moc_location=.*,moc_location=%libqt5_bindir/moc," -e "s,uic_location=.*,uic_location=%libqt5_bindir/uic," {} \;
find %{buildroot}/%{_libdir} -type f -name '*pc' -exec sed -i -e "/^RPM_BUILD_DIR/d" {} \;
sed -i '/^Libs.private/d' %{buildroot}%{_libdir}/pkgconfig/Qt*Web*.pc
# kill .la files
rm -f %{buildroot}%{_libqt5_libdir}/lib*.la
# webenginecore expects icudatl.dat at this location
ln -sf %{_datadir}/icu/*/icudt*l.dat %{buildroot}%{_datadir}/qt5/icudtl.dat

%files
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_libdir}/libQt*Web*.so.*
%{_datadir}/qt5/
%{_libqt5_plugindir}/qtwebengine/
%dir %{_libqt5_libexecdir}
%{_libqt5_libexecdir}/QtWebEngineProcess
%{_libqt5_archdatadir}/qml/QtWebEngine/

%files private-headers-devel
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_includedir}/*/%{so_version}

%files devel
%defattr(-,root,root,755)
%doc LICENSE.*
%exclude %{_libqt5_includedir}/*/%{so_version}
%{_libqt5_includedir}/*/
%{_libqt5_libdir}/cmake/Qt5Web*/
%{_libqt5_libdir}/libQt*Web*.so
%{_libqt5_libdir}/libQt*Web*.prl
%{_libqt5_libdir}/qt5/mkspecs/modules/qt_lib_*.pri
%{_libqt5_libdir}/pkgconfig/Qt*Web*.pc

%files examples
%defattr(-,root,root,755)
%doc LICENSE.*
%{_libqt5_examplesdir}/

%changelog
